import {getopenId} from "../requests/api";
async function checkSession(){
  return new Promise((resolve, reject) => {
    wx.checkSession({
      success() {
        resolve(true)
      },
      fail() {
        resolve(false)
      }
    })
  })
}
async function login(){
  return new Promise((resolve,reject)=>{
    wx.login({
      success:async function (res) {
        // 进行登录操作
        resolve(res)
        
      },
      fail:function (err){
        wx.showToast({
          title: '获取code失败',
          icon: 'none'
        })
        reject(err);
      }
    })
  })
}
// 检测登录状态，返回 true / false
async function checkHasLogined() {
  const openId = wx.getStorageSync('openId');
  if (!openId) {
    return false
  }
  const loggined = await checkSession();
  if (!loggined) {
    wx.removeStorageSync('openId')
    return false
  }
  return true
}

function wxaCode(){
  return new Promise((resolve, reject) => {
    wx.login({
      success(res) {
        return resolve(res.code)
      },
      fail() {
        wx.showToast({
          title: '获取code失败',
          icon: 'none'
        })
        return resolve('获取code失败')
      }
    })
  })
}
function getUserInfo() {
  return new Promise((resolve, reject) => {
    wx.getUserInfo({
      success: res => {
         resolve(res)
      },
      fail: err => {
        reject(err)
      }
    })
  })
}

module.exports = {
  checkHasLogined: checkHasLogined,
  wxaCode: wxaCode,
  getUserInfo: getUserInfo,
  login: login,
}